include:
- local: git-version-setup.yml
- local: multi-maven.yml
- local: jacoco-test.yml
- local: pitest-test.yml

java-test-jacoco:
  extends: .maven
  stage: test
  script:
  - !reference [.multi-maven, do-in-modules, init]
  - !reference [.multi-maven, do-in-modules, declare-function]
  - !reference [.multi-maven, scripts, avoid-version-overlap]
  - mvn compile test
  - echo "$REPORT_PARSER">parse-report.awk
  - !reference [.jacoco, scripts, print-as-ascii]
  - !reference [.jacoco, scripts, test-coverage]
  variables:
    REPORT_PARSER: !reference [.jacoco, functions, parse-report]
  artifacts:
    paths:
    - "$MAVEN_WORK_DIR/target/site/jacoco/"
    - "$MAVEN_WORK_DIR/*/target/site/jacoco/"
    when: always
    reports:
      junit:
      - "$MAVEN_WORK_DIR/target/surefire-reports/TEST-*.xml"
      - "$MAVEN_WORK_DIR/*/target/surefire-reports/TEST-*.xml"
  coverage: '/Code coverage total ([0-9]+\.[0-9]+)/'

java-test-pitest:
  extends: .maven
  stage: test
  script:
  - !reference [.multi-maven, do-in-modules, init]
  - !reference [.multi-maven, do-in-modules, declare-function]
  - !reference [.multi-maven, scripts, avoid-version-overlap]
  - mvn compile test-compile pitest:mutationCoverage -DfailWhenNoMutations=false
  - echo "$REPORT_PARSER">parse-report.awk
  - !reference [.pitest, scripts, print-as-ascii]
  - !reference [.pitest, scripts, test-coverage]
  variables:
    REPORT_PARSER: !reference [.pitest, functions, parse-report]
  artifacts:
    paths:
    - "$MAVEN_WORK_DIR/target/pit-reports/"
    - "$MAVEN_WORK_DIR/*/target/pit-reports/"
    when: on_failure
